leetcode-890-Find-and-Replace-Pattern

描述


You have a list of words and a pattern, and you want to know which words in words matches the pattern.

A word matches the pattern if there exists a permutation of letters p so that after replacing every letter x in the pattern with p(x), we get the desired word.

(Recall that a permutation of letters is a bijection from letters to letters: every letter maps to another letter, and no two letters map to the same letter.)

Return a list of the words in words that match the given pattern.

You may return the answer in any order.

Example 1:

1
2
3
4
5
Input: words = ["abc","deq","mee","aqq","dkd","ccc"], pattern = "abb"
Output: ["mee","aqq"]
Explanation: "mee" matches the pattern because there is a permutation {a -> m, b -> e, ...}.
"ccc" does not match the pattern because {a -> c, b -> c, ...} is not a permutation,
since a and b map to the same letter.

Note:

  • 1 <= words.length <= 50
  • 1 <= pattern.length = words[i].length <= 20

分析


这个题目实际上是要考察如何判断 A,B 两个集合是否存在一一对应的关系,我们知道哈希映射可以解决单向的 k-v 对应关系,如果要判断一一对应的关系,可以使用一次正向,一次反向两次哈希映射来实现。

解决方案1(Java)


1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
class Solution {
public List<String> findAndReplacePattern(String[] words, String pattern) {
List<String> result = new ArrayList();
for (String word: words) {
if (match(word, pattern)) {
result.add(word);
}
}
return result;
}

private boolean match(String word, String pattern) {
Map<Character, Character> mapWord2Pattern = new HashMap();
Map<Character, Character> mapPattern2Word = new HashMap();

for (int i = 0; i < word.length(); i++) {
char w = word.charAt(i);
char p = pattern.charAt(i);
if (!mapWord2Pattern.containsKey(w)) {
mapWord2Pattern.put(w, p);
}
if (!mapPattern2Word.containsKey(p)) {
mapPattern2Word.put(p, w);
}
if (mapWord2Pattern.get(w) != p || mapPattern2Word.get(p) != w) {
return false;
}
}
return true;
}
}

题目来源